try:
    from vcCommand import * 
    import vcMatrix, vcVector
    import csv
    from vcScript import *
except:
    print "Modules not found"

cmd = getCommand()
app = cmd.Application
sim = cmd.Simulation

def OnStart():
  global path, import_option, btn_click
  global Signal_Name, Signal_Type,VCSignal_Type

  path = cmd.createProperty(VC_URI, 'Select CSV')
  import_option = cmd.createProperty(VC_STRING, 'Import as', VC_PROPERTY_STEP)
  import_option.StepValues = ['ImportSignalList']
  import_option.Value = 'ImportSignalList'
  btn_click = cmd.createProperty(VC_BUTTON, 'Import')
  executeInActionPanel()
  btn_click.OnChanged = ImportFromCSV


def addSignal():
    global Signal_Name, Signal_Type,VCSignal_Type
    comp = app.Components[component_name]
    if not comp:
        print(f"Component not found.")
        return
    # 为组件添加信号
    Foo = comp.findBehaviour(Signal_Name)
    if not Foo:
        Foo=comp.createBehaviour(VCSignal_Type,Signal_Name)
    print(f"Signal '{signal_name}' added to component '{component_name}'.")

def ImportFromCSV(prop):
  '''
  Import from cvs file row format\n
  SignalName,Type,Value
  Signal1,BoolSignal,TRUE
  Signal2,IntegerSignal,11
  Signal3,RealSignal,5.123
  Signal4,StringSignal,A001
  '''
  global Signal_Name, Signal_Type,VCSignal_Type

  uri = path.Value[8:]
  with open(uri) as csv_file:
    next(csv_file) #Skip the first line
    csv_reader = csv.reader(csv_file, delimiter = ',')
    for row in csv_reader:
      Signal_Name = str(row[0])
      Signal_Type = str(row[1])
      if NewSignal_Type = 'BoolSignal':
        VCSignal_Type = VC_BOOLEANSIGNAL

      if NewSignal_Type = 'StringSignal':
        VCSignal_Type = VC_STRINGSIGNAL

      if NewSignal_Type = 'IntegerSignal':
        VCSignal_Type = VC_INTEGERSIGNAL

      if NewSignal_Type = 'RealSignal':
        VCSignal_Type = VC_REALSIGNAL

def SimulationOnStartStop(sim, IsRunning):
  cmd.Enabled = True
  if IsRunning:
    cmd.Enabled = False
  else:
    cmd.Enabled = True

sim.OnStartStop = SimulationOnStartStop